/**
 * Created by chen on 2017/8/1.
 */

var subRateObject={
    views:null,
    datas:null,
    valueMap:null,
    canEdit:true,
    columns: [
        {
            id: 'name',
            caption: '参数名称',
            dataField: 'name',
            width: 250,
            allowEditing: false
        },
        {
            id: 'typeName',
            caption: '参数值',
            dataField: 'typeName',
            width: 200,
            minWidth: 50,
            allowEditing: true,
            presenter:'<div><select class="form-control form-control-sm" id="{{=it.ID}}" onchange="subRateObject.subRateChange(this)" style="width: 100%">  </select></div>'
        },
        {
            id: 'ID',
            caption: 'ID',
            dataField: 'ID',
            width: 80,
            visible: false,
            allowEditing: false
        }
    ],
    options :{
        allowSorting: false,
        showRowHeader: true,
        colMinWidth: 80,
        rowHeight: 33,
        allowEditing: this.canEdit,
        editMode: 'inline',
        editUnit: 'cell',
        selectionUnit:(this.canEdit == true) ? "cell" : "row"
    },
    createSpreadView:function () {
        if (this.views) {
            this.views.destroy();
            this.views = null;
        }
        this.views = new GC.Spread.Views.DataView($('#subRate')[0],
            this.datas, this.columns, new GC.Spread.Views.Plugins.GridLayout(this.options));

        this.views["rowDbClick"].addHandler(function () {
            console.log('hh')
        });
        this.views.invalidate();
        document.querySelector('#subRate').focus();
        this.addComboboxOption(this.datas);

    },
       reFreshRateViews:function(sender,args) {
        subRateObject.datas = projectObj.project.FeeRate.getSubViewData(args.item);
        subRateObject.valueMap=projectObj.project.FeeRate.getValueMap(args.item);
        subRateObject.createSpreadView();
    },
    addComboboxOption:function (datas) {
        //<option value ="volvo">Volvo</option> <option value ="saab">Saab</option> <option value="opel">Opel</option> <option value="audi">Audi</option>
        _.forEach(datas,function (item) {
            var selectvalue = 0;
            _.forEach(item.optionList,function (o) {
                var option =  $("<option>").val(o.value).text(o.name);
                $('#'+item.ID).append(option);
                if(o.selected){
                    selectvalue = o.value;
                }
            })
            $('#'+item.ID).val(selectvalue);
        })
    },
    subRateChange:function(select){
        var me = subRateObject;
        var selectValueList=[];
        var selectMap={};
        if(me.datas&&me.datas.length>0){
            _.forEach(me.datas,function (d,key) {
                var selectValue = $('#'+d.ID).val();
                selectValueList.push(selectValue);
                selectMap[key]=selectValue;
            })
            var mapID =selectValueList.join('-');
           var  rate = me.valueMap[mapID];
            feeRateObject.updateBySelect(rate,selectMap,mapID);
        }
    },
    destorySpreadView:function () {
        if(this.views){
            this.views.destroy();
            this.views = null;
        }
        subRateObject.datas=null;
        subRateObject.valueMap=null;
    }
}
